
#pragma once

#include "common.h"
#include "Console.h"

#define ENEMY_SIZE          3			

class Enemy
{
private:
	int x;
	int y;	
	int LiveFlag;
	int StartX;		
	int MoveFlag;
	char EnemyUnit[ENEMY_SIZE + 1];
public:
	Enemy();
	~Enemy(){;}
	void Init(int _x, int _y, int _startX);
	void SetPosition(int _x, int _y);
public:
	void SetX(int _x)			{	this->x = _x;	}
    void SetY(int _y)			{	this->y = _y;	}
	void SetLiveFlag(int _Flag) {LiveFlag = _Flag;  }
	void SetMoveFlag(int _MoveFlag){ this->MoveFlag = _MoveFlag;}
public:
	int GetX(void)          {   return x;        }
    int GetY(void)          {   return y;        }
    int GetLiveFlag(void)   {   return LiveFlag;	}
	int GetMoveFlag(void)	{ return this->MoveFlag;}
public:
	void DrawEnemy(void);
	void EnemyAction(void);
public:
	/*	Ѿ˰ ʹ̿ 浹 üũϴ Լ	*/
	bool CollisionWithShot(int _shotX, int _shotY);
};

Enemy::Enemy()
{
	x = 0;
	y = 0;
	LiveFlag = 0;

	strcpy( this->EnemyUnit, "@-@" );
}

void Enemy::Init(int _x, int _y, int _startX)
{
	SetPosition( _x, _y );
	
	this->StartX = _startX;

	this->LiveFlag = 1;
}

void Enemy::SetPosition(int _x, int _y)
{
	this->SetX( _x );
	this->SetY( _y );
}

void Enemy::DrawEnemy(void)
{
	int j;
	
	int leftX;			

	if ( this->LiveFlag == 0 ) 
			return;
		
	leftX = x - ENEMY_SIZE / 2;
	
	if ( y < 0 || y >= HEIGHT ) 
		return;
	
	for ( j = 0; j < ENEMY_SIZE; j++ ) 
	{
		if ( leftX >= 0 && leftX < WIDTH ) 
			Screen[y][leftX] = EnemyUnit[j];
		
		leftX++;
	}
}

void Enemy::EnemyAction(void)
{
	if ( this->LiveFlag ) 
	{
		if ( this->MoveFlag )	x++;
		else					x--;
			
		if ( abs( x - StartX ) > 13 ) 
		{
				y++;	
				MoveFlag = !MoveFlag;
		}
	}
}

/*	Ѿ˰ ʹ̿ 浹 üũϴ Լ	*/
bool Enemy::CollisionWithShot(int _shotX, int _shotY)
{
	if ( _shotX >= x - ENEMY_SIZE / 2 && 
		 _shotX <= x + ENEMY_SIZE / 2 && _shotY == y 
	   ) 
	{	
		LiveFlag = 0;	
		return true;
	}
	return false;
}